module Routes where

import Core
  
import qualified Data.Text as T
import Lucid                  (Html)
import Servant
import Servant.HTML.Lucid

--
-- Routes
--
type Root = Get '[HTML] (Html ())

type UserList = "user"
  :> Get '[HTML] (Html ())

type UserGet = "user"
  :> Capture "userId" UserId 
  :> Get '[JSON] User

type UserPost = "user"
  :> ReqBody '[PlainText] T.Text
  :> PostCreated '[PlainText] NoContent

type UserDelete = "user"
  :> Capture "userId" UserId
  :> Delete '[PlainText] NoContent

type AppAPI = Root
  :<|> UserList
  :<|> UserGet
  :<|> UserPost
  :<|> UserDelete
